/// <reference types="koa" />
import multer from 'multer';
import compose from 'koa-compose';
import { OpenAPIV3, ValidateRequestOpts, ValidateSecurityOpts, Format } from 'openapi-core';
export interface KoaOpenApiValidatorOpts {
    apiSpec: OpenAPIV3.Document | string;
    validateRequests?: boolean | ValidateRequestOpts;
    validateSecurity?: boolean | ValidateSecurityOpts;
    ignorePaths?: RegExp | Function;
    coerceTypes?: boolean | 'array';
    unknownFormats?: true | string[] | 'ignore';
    formats?: Format[];
    fileUploader?: boolean | multer.Options;
    $refParser?: {
        mode: 'bundle' | 'dereference';
    };
    validateFormats?: false | 'fast' | 'full';
}
export declare const error: {
    InternalServerError: typeof import("openapi-core").InternalServerError;
    UnsupportedMediaType: typeof import("openapi-core").UnsupportedMediaType;
    RequestEntityTooLarge: typeof import("openapi-core").RequestEntityTooLarge;
    BadRequest: typeof import("openapi-core").BadRequest;
    MethodNotAllowed: typeof import("openapi-core").MethodNotAllowed;
    NotAcceptable: typeof import("openapi-core").NotAcceptable;
    NotFound: typeof import("openapi-core").NotFound;
    Unauthorized: typeof import("openapi-core").Unauthorized;
    Forbidden: typeof import("openapi-core").Forbidden;
};
export declare const middleware: (opts: KoaOpenApiValidatorOpts) => compose.ComposedMiddleware<import("koa").ParameterizedContext<import("koa").DefaultState, import("koa").DefaultContext>>;
